from utils import read_config, save_csv, read_csv_to_df, decide_logistic_class, determine_price, determine_price_after_shipping, read_classes, read_multipliers, read_sku_list, COLUMNS
from datetime import datetime
import pandas as pd
import time

now = datetime.now()
date_time = now.strftime("%H_%M_%d_%m_%Y")

def execute(multipliers, discount_multipliers, sku_list, logistic_classes, logistic_class_amounts):
    config = read_config()
    for file in config:
        new_products = []
        multiplier = file['multiplier']
        aa = file['amount_added']
        names = file['csv_name'].replace('.csv', '').split('_')
        leadtime_to_ship = file['leadtime_to_ship']
        
        feed_csv = read_csv_to_df('download/feed_'+names[0]+'.csv')
        bigbang_csv = read_csv_to_df('download/'+file['csv_name'])
        bigbang_csv = bigbang_csv.rename(columns={'product-id': 'product_id', 'product-id-type': 'product_id_type', 'discount-start-date': 'discount_start_date', 'discount-end-date': 'discount_end_date', 'discount-price': 'discount_price'})
        
        inner_join = pd.merge(bigbang_csv, feed_csv, how='left', left_on=['sku'], right_on=['sku_feed'])
        len = inner_join.shape[0]
        discount_counter = 0
        for prod in inner_join.itertuples():
            print(prod)
            print('\n')
            print(f"{getattr(prod, 'Index')}/{len}", end='\r')
            new_product = dict.fromkeys(COLUMNS, '')
            new_product['sku'] = str(getattr(prod, 'sku')).replace('.0', '')
            new_product['leadtime-to-ship'] = leadtime_to_ship
            new_product['product-id'] = getattr(prod, 'product_id')
            new_product['product-id-type'] = getattr(prod, 'product_id_type')
            new_product['discount-start-date'] = getattr(prod, 'discount_start_date')
            new_product['discount-end-date'] = getattr(prod, 'discount_end_date')
            new_product['discount-price'] = getattr(prod, 'discount_price')
            if pd.notna(getattr(prod, 'sku_feed')):
                new_product['quantity'] = str(getattr(prod, 'stock_feed')).replace('.0', '')
                new_product['price'] = determine_price(multipliers, getattr(prod, 'price_feed'))
                new_product['logistic-class'] = decide_logistic_class(logistic_classes, new_product['price'])
                new_product['price'] = determine_price_after_shipping(new_product['price'], new_product['logistic-class'], logistic_class_amounts)
                if int(new_product['sku']) in sku_list:
                    discount_counter += 1
                    new_product['discount-start-date'] = "2024-03-15T14:00:00.000+01:00"
                    new_product['discount-end-date'] = "2024-05-31T00:00:00.000+01:00"
                    new_product['discount-price'] = determine_price(discount_multipliers, getattr(prod, 'price_feed'))
                    new_product['logistic-class'] = decide_logistic_class(logistic_classes, new_product['discount-price'])
                    new_product['discount-price'] = determine_price_after_shipping(new_product['discount-price'], new_product['logistic-class'], logistic_class_amounts)
                    new_product['price'] = round(new_product['discount-price'] * 1.11, 2)
            else:
                new_product['quantity'] = '0'
                new_product['price'] = float(getattr(prod, 'price'))
            if int(new_product['quantity']) < 4:
                new_product['quantity'] = '0'
            if float(new_product['price']) < 3.99:
                new_product['price'] = '3.99'
            new_products.append(new_product)
        print('discounted products ', discount_counter)
        save_csv('results/'+file['csv_name'], new_products)
        
if __name__ == "__main__":
    logistic_classes, logistic_class_amounts = read_classes()
    multipliers = read_multipliers('download/multipliers.csv')
    discount_multipliers = read_multipliers('download/discount_multipliers.csv')
    sku_list = read_sku_list()
    execute(multipliers, discount_multipliers, sku_list, logistic_classes, logistic_class_amounts)
